## rr 5.1.0

=== CMakeLists.txt ===
# *-* Mode: cmake; *-*

cmake_minimum_required(VERSION 2.8.5)
project(rr C CXX ASM)

# "Do not add flags to export symbols from executables without the ENABLE_EXPORTS target property."
# This avoids linking executables with -rdynamic. -rdynamic has been observed
# to cause rr_exec_stub to be linked with the dynamic linker with some
# version(s) of clang (but linked to an incorrect file name, causing
# exec of rr_exec_stub to fail).
if(POLICY CMP0065)
  cmake_policy(SET CMP0065 NEW)
endif()

# On single configuration generators, make Debug the default configuration
if(NOT CMAKE_CONFIGURATION_TYPES)
  if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "Whether to build in `Debug` or `Release` mode." FORCE)
  endif()
endif()

enable_testing()
set(BUILD_SHARED_LIBS ON)

set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib/rr)

set(BUILD_TESTS ON CACHE BOOL "Build tests")
set(WILL_RUN_TESTS ${BUILD_TESTS} CACHE BOOL "Run tests")

# CAREFUL!  "-" is an invalid character in RPM package names, while
# debian is happy with it.  However, "_" is illegal in debs, while RPM
# is cool with it.  Sigh.
set(rr_VERSION_MAJOR 5)
set(rr_VERSION_MINOR 1)
set(rr_VERSION_PATCH 0)

add_definitions(-DRR_VERSION="${rr_VERSION_MAJOR}.${rr_VERSION_MINOR}.${rr_VERSION_PATCH}")

set(FLAGS_COMMON "-msse2 -D__MMX__ -D__SSE__ -D__SSE2__ -D__USE_LARGEFILE64 -pthread -g3")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${FLAGS_COMMON} -Wstrict-prototypes -std=gnu11")
# Define __STDC_LIMIT_MACROS so |#include <stdint.h>| works as expected.
# Define __STDC_FORMAT_MACROS so |#include <inttypes.h>| works as expected.
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS_COMMON} -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++11")
set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} -g3")

set(RR_FLAGS_DEBUG "-Wall -Wextra -Werror -O0 -DDEBUG -UNDEBUG")
set(RR_FLAGS_RELEASE "-Wall -Wextra -O2 -UDEBUG -DNDEBUG")
set(RR_TEST_FLAGS "${RR_FLAGS_DEBUG}")
if(CMAKE_BUILD_TYPE MATCHES "Debug")
  set(RR_FLAGS ${RR_FLAGS_DEBUG})
else()
  set(RR_FLAGS ${RR_FLAGS_RELEASE})
endif()

if(CMAKE_C_COMPILER_ID STREQUAL "Clang")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-command-line-argument")
endif()
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-command-line-argument")
endif()

option(force32bit "Force a 32-bit rr build, rather than both 64 and 32-bit. rr will only be able to record and replay 32-bit processes.")
option(disable32bit "On a 64-bit platform, avoid requiring a 32-bit cross-compilation toolchain by not building 32-bit components. rr will be able to record 32-bit processes but not replay them.")

if(force32bit)
  set(rr_32BIT true)
  set(rr_64BIT false)
  set(rr_MBITNESS_OPTION -m32)
else()
  if(CMAKE_SIZEOF_VOID_P EQUAL 8)
    if(disable32bit)
      set(rr_32BIT false)
    else()
      set(rr_32BIT true)
    endif()
    set(rr_64BIT true)
  else()
    set(rr_32BIT true)
    set(rr_64BIT false)
  endif()
  set(rr_MBITNESS_OPTION)
endif()

option(staticlibs "Force usage of static linkage for non-standard libraries like capnproto")

# Check that compiling 32-bit code on a 64-bit target works, if required.
if(CMAKE_HOST_SYSTEM_PROCESSOR STREQUAL "x86_64" AND rr_32BIT)
  # try_compile won't accept LINK_FLAGS, so do this manually.
  file(WRITE "${CMAKE_BINARY_DIR}/test32.c" "int main() { return 0; }")
  execute_process(COMMAND ${CMAKE_C_COMPILER} -o ${CMAKE_BINARY_DIR}/test32 ${CMAKE_BINARY_DIR}/test32.c -m32
			RESULT_VARIABLE COMPILER_32BIT_RESULT)
  if(NOT (COMPILER_32BIT_RESULT EQUAL 0))
    message(FATAL_ERROR "Your toolchain doesn't support 32-bit cross-compilation. Install the required packages or pass -Ddisable32bit=ON to cmake.")
  endif()
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${rr_MBITNESS_OPTION}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${rr_MBITNESS_OPTION}")
set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} ${rr_MBITNESS_OPTION}")

find_package(PkgConfig REQUIRED)

# If we're cross-compiling a 32-bit rr build on a 64-bit host we need
# to ensure we're looking for the right libraries.
# This has been tested on Ubuntu and Fedora.
if(CMAKE_HOST_SYSTEM_PROCESSOR STREQUAL "x86_64" AND NOT rr_64BIT)
  set(LIBDIR32_CANDIDATES
    /usr/lib/i386-linux-gnu/pkgconfig/
    /usr/lib/pkgconfig/
  )
  foreach(libdir ${LIBDIR32_CANDIDATES})
    if(IS_DIRECTORY ${libdir})
      set(ENV{PKG_CONFIG_LIBDIR} ${libdir})
      break()
     endif()
   endforeach(libdir)
   if(NOT DEFINED ENV{PKG_CONFIG_LIBDIR})
     message(FATAL_ERROR "Couldn't find a suitable 32-bit pkgconfig lib dir. You probably need to install a 32-bit pkgconfig package (pkgconfig.i686 for Fedora or pkg-config:i386 for Ubuntu")
   endif()
endif()

find_program(CAPNP capnp)
if(${CAPNP} STREQUAL "CAPNP-NOTFOUND")
  message(FATAL_ERROR "Can't find 'capnp' command; install Capnproto packages? https://github.com/mozilla/rr/wiki/Building-And-Installing#tldr")
endif()

set(REQUIRED_LIBS
  capnp
)

foreach(required_lib ${REQUIRED_LIBS})
  string(TOUPPER ${required_lib} PKG)
  pkg_check_modules(${PKG} REQUIRED ${required_lib})
  if(staticlibs)
    string(REPLACE ";" " " ${PKG}_STATIC_CFLAGS "${${PKG}_STATIC_CFLAGS}")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${${PKG}_STATIC_CFLAGS}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${${PKG}_STATIC_CFLAGS}")
  else()
    string(REPLACE ";" " " ${PKG}_CFLAGS "${${PKG}_CFLAGS}")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${${PKG}_CFLAGS}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${${PKG}_CFLAGS}")
  endif()
endforeach(required_lib)

# ==== brotli ====
set(BROTLI_FILES
  third-party/brotli/common/dictionary.c
  third-party/brotli/dec/bit_reader.c
  third-party/brotli/dec/decode.c
  third-party/brotli/dec/huffman.c
  third-party/brotli/dec/state.c
  third-party/brotli/enc/backward_references.c
  third-party/brotli/enc/backward_references.h
  third-party/brotli/enc/backward_references_hq.c
  third-party/brotli/enc/backward_references_hq.h
  third-party/brotli/enc/backward_references_inc.h
  third-party/brotli/enc/bit_cost.c
  third-party/brotli/enc/bit_cost.h
  third-party/brotli/enc/bit_cost_inc.h
  third-party/brotli/enc/block_encoder_inc.h
  third-party/brotli/enc/block_splitter.c
  third-party/brotli/enc/block_splitter.h
  third-party/brotli/enc/block_splitter_inc.h
  third-party/brotli/enc/brotli_bit_stream.c
  third-party/brotli/enc/brotli_bit_stream.h
  third-party/brotli/enc/cluster.c
  third-party/brotli/enc/cluster.h
  third-party/brotli/enc/cluster_inc.h
  third-party/brotli/enc/command.h
  third-party/brotli/enc/compress_fragment.c
  third-party/brotli/enc/compress_fragment.h
  third-party/brotli/enc/compress_fragment_two_pass.c
  third-party/brotli/enc/compress_fragment_two_pass.h
  third-party/brotli/enc/context.h
  third-party/brotli/enc/dictionary_hash.c
  third-party/brotli/enc/dictionary_hash.h
  third-party/brotli/enc/encode.c
  third-party/brotli/enc/entropy_encode.c
  third-party/brotli/enc/entropy_encode.h
  third-party/brotli/enc/entropy_encode_static.h
  third-party/brotli/enc/fast_log.h
  third-party/brotli/enc/find_match_length.h
  third-party/brotli/enc/hash_forgetful_chain_inc.h
  third-party/brotli/enc/hash.h
  third-party/brotli/enc/hash_longest_match64_inc.h
  third-party/brotli/enc/hash_longest_match_inc.h
  third-party/brotli/enc/hash_longest_match_quickly_inc.h
  third-party/brotli/enc/hash_to_binary_tree_inc.h
  third-party/brotli/enc/histogram.c
  third-party/brotli/enc/histogram.h
  third-party/brotli/enc/histogram_inc.h
  third-party/brotli/enc/literal_cost.c
  third-party/brotli/enc/literal_cost.h
  third-party/brotli/enc/memory.c
  third-party/brotli/enc/memory.h
  third-party/brotli/enc/metablock.c
  third-party/brotli/enc/metablock.h
  third-party/brotli/enc/metablock_inc.h
  third-party/brotli/enc/port.h
  third-party/brotli/enc/prefix.h
  third-party/brotli/enc/quality.h
  third-party/brotli/enc/ringbuffer.h
  third-party/brotli/enc/static_dict.c
  third-party/brotli/enc/static_dict.h
  third-party/brotli/enc/static_dict_lut.h
  third-party/brotli/enc/utf8_util.c
  third-party/brotli/enc/utf8_util.h
  third-party/brotli/enc/write_bits.h
)
add_library(brotli STATIC ${BROTLI_FILES})
set_source_files_properties(${BROTLI_FILES}
                            PROPERTIES COMPILE_FLAGS ${RR_FLAGS_RELEASE})
# ==== brotli ====

find_path(SECCOMP NAMES "linux/seccomp.h")
if(NOT SECCOMP)
  message(FATAL_ERROR "Couldn't find linux/seccomp.h. You may need to upgrade your kernel.")
endif()

# Check for Python >=2.7 but not Python 3.
find_package(PythonInterp 2.7 REQUIRED)
if(PYTHON_VERSION_MAJOR GREATER 2)
  message(FATAL_ERROR "Python 3 is not supported, please use Python 2.7.")
endif()

execute_process(COMMAND "${PYTHON_EXECUTABLE}" "-c" "# nothing"
                RESULT_VARIABLE python_status)
if(python_status)
  message(FATAL_ERROR "Couldn't run python interpreter ${PYTHON_EXECUTABLE}.")
endif()

# Check for required Python modules
if(WILL_RUN_TESTS)
  if(NOT BUILD_TESTS)
    message(FATAL_ERROR "Running tests requires building them")
  endif()

  set(REQUIRED_PYTHON_MODULES
    pexpect
  )
else()
  set(REQUIRED_PYTHON_MODULES)
endif()

foreach(py_module ${REQUIRED_PYTHON_MODULES})
  execute_process(COMMAND "${PYTHON_EXECUTABLE}" "-c"
			"import ${py_module}"
			RESULT_VARIABLE module_status)
  if(module_status)
    message(FATAL_ERROR "Couldn't find required Python module ${py_module}.")
  endif()
endforeach(py_module)

if(WILL_RUN_TESTS)
  # Check for gdb
  execute_process(COMMAND "gdb" "--version" RESULT_VARIABLE module_status OUTPUT_QUIET)
  if(module_status)
    message(FATAL_ERROR "Couldn't find gdb.")
  endif()
endif()

set(PRELOAD_COMPILE_FLAGS "-fno-stack-protector")

if (DEBUG_PRELOAD_LIB)
  set(PRELOAD_COMPILE_FLAGS "${PRELOAD_COMPILE_FLAGS} ${RR_FLAGS_DEBUG}")
else()
  set(PRELOAD_COMPILE_FLAGS "${PRELOAD_COMPILE_FLAGS} ${RR_FLAGS_RELEASE}")
endif()

set_source_files_properties(src/preload/syscallbuf.c
                            src/preload/overrides.c
                            PROPERTIES COMPILE_FLAGS ${PRELOAD_COMPILE_FLAGS})

include_directories("${PROJECT_SOURCE_DIR}/include")
include_directories("${PROJECT_SOURCE_DIR}/third-party/proc-service")
include_directories("${PROJECT_SOURCE_DIR}/third-party/brotli/include")
# We need to know where our generated files are.
include_directories("${CMAKE_CURRENT_BINARY_DIR}")

# Order matters here! syscall_hook.S must be immediately before syscallbuf.c,
# breakpoint_table.S must be before overrides.c, which must be last.
add_library(rrpreload
  src/preload/syscall_hook.S
  src/preload/syscallbuf.c
  src/preload/raw_syscall.S
  src/preload/breakpoint_table.S
  src/preload/overrides.c
)
set_target_properties(rrpreload PROPERTIES LINK_FLAGS "-nostartfiles")

# Ensure that CMake knows about our generated files.
#
# Alphabetical, please.
set(GENERATED_FILES
  AssemblyTemplates.generated
  CheckSyscallNumbers.generated
  SyscallEnumsX64.generated
  SyscallEnumsX86.generated
  SyscallEnumsForTestsX64.generated
  SyscallEnumsForTestsX86.generated
  SyscallHelperFunctions.generated
  SyscallnameArch.generated
  SyscallRecordCase.generated
)

foreach(generated_file ${GENERATED_FILES})
  set_source_files_properties(${generated_file}
                              PROPERTIES GENERATED true HEADER_FILE_ONLY true)
  add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${generated_file}"
                     COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_syscalls.py"
		               "${CMAKE_CURRENT_BINARY_DIR}/${generated_file}"
		     DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_syscalls.py"
		       "${CMAKE_CURRENT_SOURCE_DIR}/src/syscalls.py"
		       "${CMAKE_CURRENT_SOURCE_DIR}/src/assembly_templates.py")
endforeach(generated_file)

add_custom_target(Generated DEPENDS ${GENERATED_FILES})

add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_64"

=== debian/changelog ===
rr (5.1.0-1) unstable; urgency=medium

  * New upstream release.
  * Refer to the common-licenses CC0 copy in debian/copyright.
  * Switch to debhelper compatibility level 11.
  * Standards-Version 4.1.3, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Mon, 08 Jan 2018 11:51:50 +0100

rr (5.0.0-1) unstable; urgency=medium

  * New upstream release:
    - merge gcc-7.patch;
    - add build-dependencies for Cap'n Proto;
    - document new third-party code;
    - drop documentation, no longer shipped;
    - enable PIE.
  * Standards-Version 4.1.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Fri, 08 Sep 2017 19:13:07 +0200

=== debian/control ===
Source: rr
Maintainer: Stephen Kitt <skitt@debian.org>
Section: devel
Priority: optional
Build-Depends: capnproto,
               cmake,
               debhelper (>= 11~),
               g++-multilib,
               gdb,
               libcapnp-dev,
               libdisasm-dev,
               libpfm4-dev,
               pkg-config,
               python,
               python-pexpect
# The following are required for the test suite
# realpath
Standards-Version: 4.1.3
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/rr.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/rr.git
Homepage: http://rr-project.org

Package: rr
Architecture: amd64 i386
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: application execution recorder, player and debugger
 rr allows application executions to be recorded and then replayed
 with gdb as many times as desired.
 .
 This allows intermittent, or complex to reproduce, bugs to be
 captured and then debugged at leisure. Replays are deterministic,
 always identical from one run to another.
 .
 rr is incompatible with ptrace hardening, and currently only supports
 Intel CPUs with Nehalem or later microarchitectures.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DH_OPTIONS += -O-Bbuild

override_dh_auto_test:
# Tests are disabled since they only work on supported CPUs
# (Intel CPUs from Nehalem onwards)

override_dh_auto_install:
	dh_auto_install
	mv debian/rr/usr/bin/signal-rr-recording.sh debian/rr/usr/bin/signal-rr-recording
	mv debian/rr/usr/bin/rr_* debian/rr/usr/lib/rr/

%:
	dh $@ --buildsystem=cmake

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rr-$1.tar.gz%,repacksuffix=+dfsg,dversionmangle=s%\+dfsg%%" \
    https://github.com/mozilla/rr/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## rr 5.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,6 +24,7 @@
 
 set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
 set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib/rr)
+set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 
 set(BUILD_TESTS ON CACHE BOOL "Build tests")
 set(WILL_RUN_TESTS ${BUILD_TESTS} CACHE BOOL "Run tests")
@@ -32,7 +33,7 @@
 # debian is happy with it.  However, "_" is illegal in debs, while RPM
 # is cool with it.  Sigh.
 set(rr_VERSION_MAJOR 5)
-set(rr_VERSION_MINOR 1)
+set(rr_VERSION_MINOR 2)
 set(rr_VERSION_PATCH 0)
 
 add_definitions(-DRR_VERSION="${rr_VERSION_MAJOR}.${rr_VERSION_MINOR}.${rr_VERSION_PATCH}")
@@ -47,7 +48,9 @@
 set(RR_FLAGS_DEBUG "-Wall -Wextra -Werror -O0 -DDEBUG -UNDEBUG")
 set(RR_FLAGS_RELEASE "-Wall -Wextra -O2 -UDEBUG -DNDEBUG")
 set(RR_TEST_FLAGS "${RR_FLAGS_DEBUG}")
-if(CMAKE_BUILD_TYPE MATCHES "Debug")
+
+string(TOLOWER ${CMAKE_BUILD_TYPE} LOWERCASE_CMAKE_BUILD_TYPE)
+if(LOWERCASE_CMAKE_BUILD_TYPE STREQUAL "debug")
   set(RR_FLAGS ${RR_FLAGS_DEBUG})
 else()
   set(RR_FLAGS ${RR_FLAGS_RELEASE})
@@ -317,4 +320,3 @@
 
 add_custom_target(Generated DEPENDS ${GENERATED_FILES})
 
-add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_64"

=== debian/changelog ===
rr (5.2.0-5ubuntu1) eoan; urgency=medium

  * Fix build with new glibc (tgkill prototype mismatch)
  * Workaround sysctl missing on new glibc with Wno-implicit-function-declaration

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 07 Sep 2019 19:22:07 +0200

rr (5.2.0-5) unstable; urgency=medium

  * Apply upstream patches to switch to Python 3. Closes: #938413.
  * Switch to debhelper compatibility level 12.
  * Standards-Version 4.4.0, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 31 Aug 2019 15:17:20 +0200

rr (5.2.0-4) unstable; urgency=medium

  * Build only on amd64, since the i386 package isn’t aligned with the
    i386 “baseline”. Closes: #915337.
  * Switch to C++14 for C++ code, as required by capnproto 0.7.
  * Standards-Version 4.3.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Wed, 02 Jan 2019 12:02:08 +0100

rr (5.2.0-3) unstable; urgency=medium

  * Apply upstream patch to drop ucontext_t, which broke with glibc 2.28.
    Closes: #915338.
  * Standards-Version 4.2.1, no change required.

 -- Stephen Kitt <skitt@debian.org>  Mon, 03 Dec 2018 08:51:54 +0100

rr (5.2.0-2) unstable; urgency=medium

  * Stop stripping librrpreload, its debug symbols are needed at runtime.
  * Set “Rules-Requires-Root: no”.
  * Standards-Version 4.2.0, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Fri, 17 Aug 2018 09:32:06 +0200

rr (5.2.0-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Tue, 29 May 2018 22:36:22 +0200

rr (5.1.0-2) unstable; urgency=medium

  * Migrate to Salsa.
  * Update debian/copyright.
  * Standards-Version 4.1.4, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Tue, 15 May 2018 21:00:13 +0200

=== debian/control ===
Source: rr
Maintainer: Stephen Kitt <skitt@debian.org>
Section: devel
Priority: optional
Build-Depends: capnproto,
               cmake,
               debhelper-compat (= 12),
               g++-multilib,
               gdb,
               libcapnp-dev,
               libdisasm-dev,
               libpfm4-dev,
               pkg-config,
               python3,
               python3-pexpect
# The following are required for the test suite
# realpath
Standards-Version: 4.4.0
Vcs-Browser: https://salsa.debian.org/debian/rr
Vcs-Git: https://salsa.debian.org/debian/rr.git
Homepage: http://rr-project.org
Rules-Requires-Root: no

Package: rr
Architecture: amd64
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: application execution recorder, player and debugger
 rr allows application executions to be recorded and then replayed
 with gdb as many times as desired.
 .
 This allows intermittent, or complex to reproduce, bugs to be
 captured and then debugged at leisure. Replays are deterministic,
 always identical from one run to another.
 .
 rr is incompatible with ptrace hardening, and currently only supports
 Intel CPUs with Nehalem or later microarchitectures. The amd64
 package supports debugging amd64 and i386 binaries.

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,11 @@
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
+export DEB_CFLAGS_MAINT_APPEND = -Wno-implicit-function-declaration
 export DH_OPTIONS += -O-Bbuild
+
+%:
+	dh $@ --buildsystem=cmake
 
 override_dh_auto_test:
 # Tests are disabled since they only work on supported CPUs
@@ -17,5 +21,8 @@
 	mv debian/rr/usr/bin/signal-rr-recording.sh debian/rr/usr/bin/signal-rr-recording
 	mv debian/rr/usr/bin/rr_* debian/rr/usr/lib/rr/
 
-%:
-	dh $@ --buildsystem=cmake
+override_dh_strip:
+	dh_strip -Xlibrrpreload
+
+override_dh_dwz:
+	dh_dwz --no-dwz-multifile

## rr 5.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # *-* Mode: cmake; *-*
 
-cmake_minimum_required(VERSION 2.8.5)
+cmake_minimum_required(VERSION 3.1.0)
 project(rr C CXX ASM)
 
 # "Do not add flags to export symbols from executables without the ENABLE_EXPORTS target property."
@@ -33,27 +33,59 @@
 # debian is happy with it.  However, "_" is illegal in debs, while RPM
 # is cool with it.  Sigh.
 set(rr_VERSION_MAJOR 5)
-set(rr_VERSION_MINOR 2)
+set(rr_VERSION_MINOR 3)
 set(rr_VERSION_PATCH 0)
 
 add_definitions(-DRR_VERSION="${rr_VERSION_MAJOR}.${rr_VERSION_MINOR}.${rr_VERSION_PATCH}")
 
-set(FLAGS_COMMON "-msse2 -D__MMX__ -D__SSE__ -D__SSE2__ -D__USE_LARGEFILE64 -pthread -g3")
+execute_process(
+  COMMAND git rev-parse HEAD
+  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
+  OUTPUT_VARIABLE GIT_REVISION
+  OUTPUT_STRIP_TRAILING_WHITESPACE
+)
+configure_file(
+  ${CMAKE_SOURCE_DIR}/src/git_revision.h.in
+  ${CMAKE_BINARY_DIR}/git_revision.h
+)
+
+set(FLAGS_COMMON "-msse2 -D__MMX__ -D__SSE__ -D__SSE2__ -D__USE_LARGEFILE64 -pthread")
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${FLAGS_COMMON} -Wstrict-prototypes -std=gnu11")
 # Define __STDC_LIMIT_MACROS so |#include <stdint.h>| works as expected.
 # Define __STDC_FORMAT_MACROS so |#include <inttypes.h>| works as expected.
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS_COMMON} -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++11")
-set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} -g3")
-
-set(RR_FLAGS_DEBUG "-Wall -Wextra -Werror -O0 -DDEBUG -UNDEBUG")
-set(RR_FLAGS_RELEASE "-Wall -Wextra -O2 -UDEBUG -DNDEBUG")
-set(RR_TEST_FLAGS "${RR_FLAGS_DEBUG}")
-
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS_COMMON} -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++14")
+
+# We support three build types:
+# DEBUG: suitable for debugging rr
+# RELEASE: suitable for using rr in production (but keeps rr debuginfo)
+# OTHER: suitable for using rr in production, but honouring distro/user opt/debug settings
+# (which we assume are suitable for production use)
+
+# Base settings for debug and release/unspecified builds.
+# Use -Werror for debug builds because we assume a developer is building, not a user.
+set(RR_FLAGS_DEBUG "-Wall -Wextra -DDEBUG -UNDEBUG")
+set(RR_FLAGS_RELEASE "-Wall -Wextra -UDEBUG -DNDEBUG")
+
+# The folowing settings are the defaults for the OTHER build type.
+# Flags used to build the preload library. MUST have debuginfo enabled. SHOULD be optimized.
+set(PRELOAD_COMPILE_FLAGS "${RR_FLAGS_RELEASE} -fno-stack-protector -g3")
+# Flags used to build Brotli. SHOULD be optimized. MUST NOT error on warnings.
+set(BROTLI_COMPILE_FLAGS ${RR_FLAGS_RELEASE})
+# Flags used to build tests. MUST have -DDEBUG and debuginfo enabled, MUST NOT be optimized.
+set(RR_TEST_FLAGS "${RR_FLAGS_DEBUG} -g3 -O0")
+# Flags used to build other files. Entirely build-type-dependent.
+set(RR_FLAGS ${RR_FLAGS_RELEASE})
+
+# Now override for build type.
 string(TOLOWER ${CMAKE_BUILD_TYPE} LOWERCASE_CMAKE_BUILD_TYPE)
 if(LOWERCASE_CMAKE_BUILD_TYPE STREQUAL "debug")
-  set(RR_FLAGS ${RR_FLAGS_DEBUG})
-else()
-  set(RR_FLAGS ${RR_FLAGS_RELEASE})
+  set(PRELOAD_COMPILE_FLAGS "${PRELOAD_COMPILE_FLAGS} -O2 -Werror")
+  set(BROTLI_COMPILE_FLAGS "${RR_FLAGS_RELEASE} -O2")
+  set(RR_TEST_FLAGS "${RR_TEST_FLAGS} -Werror")
+  set(RR_FLAGS "${RR_FLAGS_DEBUG} -g3 -Werror")
+elseif(LOWERCASE_CMAKE_BUILD_TYPE STREQUAL "release")
+  # CMake itself will add optimization flags
+  set(RR_FLAGS "${RR_FLAGS_RELEASE} -g3")
 endif()
 
 if(CMAKE_C_COMPILER_ID STREQUAL "Clang")
@@ -61,6 +93,9 @@
 endif()
 if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-command-line-argument")
+endif()
+if (CMAKE_ASM_COMPILER_ID STREQUAL "Clang")
+  set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} -fno-integrated-as")
 endif()
 
 option(force32bit "Force a 32-bit rr build, rather than both 64 and 32-bit. rr will only be able to record and replay 32-bit processes.")
@@ -149,6 +184,7 @@
 # ==== brotli ====
 set(BROTLI_FILES
   third-party/brotli/common/dictionary.c
+  third-party/brotli/common/transform.c
   third-party/brotli/dec/bit_reader.c
   third-party/brotli/dec/decode.c
   third-party/brotli/dec/huffman.c
@@ -179,6 +215,7 @@
   third-party/brotli/enc/dictionary_hash.c
   third-party/brotli/enc/dictionary_hash.h
   third-party/brotli/enc/encode.c
+  third-party/brotli/enc/encoder_dict.c
   third-party/brotli/enc/entropy_encode.c
   third-party/brotli/enc/entropy_encode.h
   third-party/brotli/enc/entropy_encode_static.h
@@ -213,7 +250,7 @@
 )
 add_library(brotli STATIC ${BROTLI_FILES})
 set_source_files_properties(${BROTLI_FILES}
-                            PROPERTIES COMPILE_FLAGS ${RR_FLAGS_RELEASE})
+                            PROPERTIES COMPILE_FLAGS ${BROTLI_COMPILE_FLAGS})
 # ==== brotli ====
 
 find_path(SECCOMP NAMES "linux/seccomp.h")
@@ -221,11 +258,8 @@
   message(FATAL_ERROR "Couldn't find linux/seccomp.h. You may need to upgrade your kernel.")
 endif()
 
-# Check for Python >=2.7 but not Python 3.
-find_package(PythonInterp 2.7 REQUIRED)
-if(PYTHON_VERSION_MAJOR GREATER 2)
-  message(FATAL_ERROR "Python 3 is not supported, please use Python 2.7.")
-endif()
+set(Python_ADDITIONAL_VERSIONS 3 3.8 3.7 3.6 3.5 3.4 3.3 3.2 3.1 3.0)
+find_package(PythonInterp 3 REQUIRED)
 
 execute_process(COMMAND "${PYTHON_EXECUTABLE}" "-c" "# nothing"
                 RESULT_VARIABLE python_status)
@@ -263,18 +297,6 @@
   endif()
 endif()
 
-set(PRELOAD_COMPILE_FLAGS "-fno-stack-protector")
-
-if (DEBUG_PRELOAD_LIB)
-  set(PRELOAD_COMPILE_FLAGS "${PRELOAD_COMPILE_FLAGS} ${RR_FLAGS_DEBUG}")
-else()
-  set(PRELOAD_COMPILE_FLAGS "${PRELOAD_COMPILE_FLAGS} ${RR_FLAGS_RELEASE}")
-endif()
-
-set_source_files_properties(src/preload/syscallbuf.c
-                            src/preload/overrides.c
-                            PROPERTIES COMPILE_FLAGS ${PRELOAD_COMPILE_FLAGS})
-
 include_directories("${PROJECT_SOURCE_DIR}/include")
 include_directories("${PROJECT_SOURCE_DIR}/third-party/proc-service")
 include_directories("${PROJECT_SOURCE_DIR}/third-party/brotli/include")
@@ -283,40 +305,12 @@
 
 # Order matters here! syscall_hook.S must be immediately before syscallbuf.c,
 # breakpoint_table.S must be before overrides.c, which must be last.
-add_library(rrpreload
-  src/preload/syscall_hook.S
-  src/preload/syscallbuf.c
-  src/preload/raw_syscall.S
-  src/preload/breakpoint_table.S
-  src/preload/overrides.c
-)
-set_target_properties(rrpreload PROPERTIES LINK_FLAGS "-nostartfiles")
-
-# Ensure that CMake knows about our generated files.
-#
-# Alphabetical, please.
-set(GENERATED_FILES
-  AssemblyTemplates.generated
-  CheckSyscallNumbers.generated
-  SyscallEnumsX64.generated
-  SyscallEnumsX86.generated
-  SyscallEnumsForTestsX64.generated
-  SyscallEnumsForTestsX86.generated
-  SyscallHelperFunctions.generated
-  SyscallnameArch.generated
-  SyscallRecordCase.generated
-)
-
-foreach(generated_file ${GENERATED_FILES})
-  set_source_files_properties(${generated_file}
-                              PROPERTIES GENERATED true HEADER_FILE_ONLY true)
-  add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${generated_file}"
-                     COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_syscalls.py"
-		               "${CMAKE_CURRENT_BINARY_DIR}/${generated_file}"
-		     DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_syscalls.py"
-		       "${CMAKE_CURRENT_SOURCE_DIR}/src/syscalls.py"
-		       "${CMAKE_CURRENT_SOURCE_DIR}/src/assembly_templates.py")
-endforeach(generated_file)
-
-add_custom_target(Generated DEPENDS ${GENERATED_FILES})
-
+set(PRELOAD_FILES
+  syscall_hook.S
+  syscallbuf.c
+  raw_syscall.S
+  breakpoint_table.S
+  overrides.c
+)
+set(PRELOAD_SOURCE_FILES
+  ${PRELOAD_FILES}

=== debian/changelog ===
rr (5.3.0-2) unstable; urgency=medium

  * Move the preload libraries back to /usr/lib/rr, with no multiarch
    subdirectories, so that rr can find them again. Thanks to Michael
    Weghorn for the patch! Closes: #951325.
  * Standards-Version 4.5.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 15 Feb 2020 11:48:21 +0100

rr (5.3.0-1) unstable; urgency=medium

  * New upstream release, merging most of the patches in this package.
  * Standards-Version 4.4.1, no change required.

 -- Stephen Kitt <skitt@debian.org>  Wed, 18 Dec 2019 18:54:01 +0100

=== debian/control ===
--- 
+++ 
@@ -5,6 +5,7 @@
 Build-Depends: capnproto,
                cmake,
                debhelper-compat (= 12),
+               dh-python,
                g++-multilib,
                gdb,
                libcapnp-dev,
@@ -15,7 +16,7 @@
                python3-pexpect
 # The following are required for the test suite
 # realpath
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/debian/rr
 Vcs-Git: https://salsa.debian.org/debian/rr.git
 Homepage: http://rr-project.org
@@ -24,6 +25,7 @@
 Package: rr
 Architecture: amd64
 Depends: ${misc:Depends},
+         ${python3:Depends},
          ${shlibs:Depends}
 Description: application execution recorder, player and debugger
  rr allows application executions to be recorded and then replayed

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DH_OPTIONS += -O-Bbuild

include /usr/share/dpkg/architecture.mk

%:
	dh $@ --buildsystem=cmake --with=python3

override_dh_auto_test:
# Tests are disabled since they only work on supported CPUs
# (Intel CPUs from Nehalem onwards)

override_dh_auto_install:
	dh_auto_install
	mv debian/rr/usr/bin/signal-rr-recording.sh debian/rr/usr/bin/signal-rr-recording
	mv debian/rr/usr/bin/rr-collect-symbols.py debian/rr/usr/bin/rr-collect-symbols
	mkdir -p debian/rr/usr/lib/rr
	mv debian/rr/usr/bin/rr_* debian/rr/usr/lib/rr/
	mv debian/rr/usr/lib/$(DEB_HOST_MULTIARCH)/rr/librrpreload* debian/rr/usr/lib/rr/
	rm -rf debian/rr/usr/lib/$(DEB_HOST_MULTIARCH)
	chmod 644 debian/rr/usr/share/bash-completion/completions/rr

override_dh_strip:
	dh_strip -Xlibrrpreload

override_dh_dwz:
	dh_dwz --no-dwz-multifile

override_dh_python3:
	dh_python3 --no-ext-rename

## rr 5.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,12 +28,13 @@
 
 set(BUILD_TESTS ON CACHE BOOL "Build tests")
 set(WILL_RUN_TESTS ${BUILD_TESTS} CACHE BOOL "Run tests")
+option(INSTALL_TESTSUITE "Install the testsuite")
 
 # CAREFUL!  "-" is an invalid character in RPM package names, while
 # debian is happy with it.  However, "_" is illegal in debs, while RPM
 # is cool with it.  Sigh.
 set(rr_VERSION_MAJOR 5)
-set(rr_VERSION_MINOR 3)
+set(rr_VERSION_MINOR 4)
 set(rr_VERSION_PATCH 0)
 
 add_definitions(-DRR_VERSION="${rr_VERSION_MAJOR}.${rr_VERSION_MINOR}.${rr_VERSION_PATCH}")
@@ -49,11 +50,27 @@
   ${CMAKE_BINARY_DIR}/git_revision.h
 )
 
-set(FLAGS_COMMON "-msse2 -D__MMX__ -D__SSE__ -D__SSE2__ -D__USE_LARGEFILE64 -pthread")
+set(FLAGS_COMMON "-D__USE_LARGEFILE64 -pthread")
+set(supports32bit true)
+set(x86ish false)
+if (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "aarch64")
+  set(supports32bit false)
+  set(FLAGS_COMMON "${FLAGS_COMMON} -march=armv8.3-a")
+else()
+  set(x86ish true)
+  set(FLAGS_COMMON "${FLAGS_COMMON} -msse2 -D__MMX__ -D__SSE__ -D__SSE2__")
+endif()
+
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${FLAGS_COMMON} -Wstrict-prototypes -std=gnu11")
 # Define __STDC_LIMIT_MACROS so |#include <stdint.h>| works as expected.
 # Define __STDC_FORMAT_MACROS so |#include <inttypes.h>| works as expected.
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS_COMMON} -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++14")
+include(CheckCXXCompilerFlag)
+CHECK_CXX_COMPILER_FLAG("-std=c++14" SUPPORTS_CXX14)
+if (SUPPORTS_CXX14)
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS_COMMON} -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++14")
+else()
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS_COMMON} -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++11")
+endif()
 
 # We support three build types:
 # DEBUG: suitable for debugging rr
@@ -68,7 +85,7 @@
 
 # The folowing settings are the defaults for the OTHER build type.
 # Flags used to build the preload library. MUST have debuginfo enabled. SHOULD be optimized.
-set(PRELOAD_COMPILE_FLAGS "${RR_FLAGS_RELEASE} -fno-stack-protector -g3")
+set(PRELOAD_COMPILE_FLAGS "${RR_FLAGS_RELEASE} -fno-stack-protector -g3 -U_FORTIFY_SOURCE")
 # Flags used to build Brotli. SHOULD be optimized. MUST NOT error on warnings.
 set(BROTLI_COMPILE_FLAGS ${RR_FLAGS_RELEASE})
 # Flags used to build tests. MUST have -DDEBUG and debuginfo enabled, MUST NOT be optimized.
@@ -85,7 +102,14 @@
   set(RR_FLAGS "${RR_FLAGS_DEBUG} -g3 -Werror")
 elseif(LOWERCASE_CMAKE_BUILD_TYPE STREQUAL "release")
   # CMake itself will add optimization flags
-  set(RR_FLAGS "${RR_FLAGS_RELEASE} -g3")
+  set(RR_FLAGS "${RR_FLAGS_RELEASE} -g3 -flto")
+endif()
+
+set(LINKER_FLAGS "")
+if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
+  # Gcc generates bogus R_386_GOTOFF relocations in .debug_info which
+  # lld 9 rejects
+  set(LINKER_FLAGS "-fuse-ld=bfd")
 endif()
 
 if(CMAKE_C_COMPILER_ID STREQUAL "Clang")
@@ -107,7 +131,7 @@
   set(rr_MBITNESS_OPTION -m32)
 else()
   if(CMAKE_SIZEOF_VOID_P EQUAL 8)
-    if(disable32bit)
+    if(disable32bit OR NOT supports32bit)
       set(rr_32BIT false)
     else()
       set(rr_32BIT true)
@@ -291,26 +315,3 @@
 
 if(WILL_RUN_TESTS)
   # Check for gdb
-  execute_process(COMMAND "gdb" "--version" RESULT_VARIABLE module_status OUTPUT_QUIET)
-  if(module_status)
-    message(FATAL_ERROR "Couldn't find gdb.")
-  endif()
-endif()
-
-include_directories("${PROJECT_SOURCE_DIR}/include")
-include_directories("${PROJECT_SOURCE_DIR}/third-party/proc-service")
-include_directories("${PROJECT_SOURCE_DIR}/third-party/brotli/include")
-# We need to know where our generated files are.
-include_directories("${CMAKE_CURRENT_BINARY_DIR}")
-
-# Order matters here! syscall_hook.S must be immediately before syscallbuf.c,
-# breakpoint_table.S must be before overrides.c, which must be last.
-set(PRELOAD_FILES
-  syscall_hook.S
-  syscallbuf.c
-  raw_syscall.S
-  breakpoint_table.S
-  overrides.c
-)
-set(PRELOAD_SOURCE_FILES
-  ${PRELOAD_FILES}

=== debian/changelog ===
rr (5.4.0-2) unstable; urgency=medium

  * Update upstream references to github.com/rr-debugger instead of
    github.com/mozilla.

 -- Stephen Kitt <skitt@debian.org>  Wed, 06 Jan 2021 08:26:47 +0100

rr (5.4.0-1) unstable; urgency=medium

  * Source-only upload to unstable.

 -- Stephen Kitt <skitt@debian.org>  Sun, 01 Nov 2020 21:17:17 +0100

rr (5.4.0-1~exp1) experimental; urgency=medium

  * New upstream release, restoring i386 support and introducing support
    for some Zen CPUs and some AArch64 platforms.
    Closes: #961710, #961926.
  * Switch to debhelper compatibility level 13.

 -- Stephen Kitt <skitt@debian.org>  Sun, 01 Nov 2020 18:12:33 +0100

rr (5.3.0-4) unstable; urgency=low

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Stephen Kitt ]
  * Apply upstream patches to support new vDSO syscalls. Closes:
    #968686.
  * The current release doesn’t work on i386 (see #961926), drop that
    architecture until the next release.
  * Allow building with g++-i686-linux-gnu as well as g++-multilib.

 -- Stephen Kitt <skitt@debian.org>  Sat, 29 Aug 2020 20:47:14 +0200

rr (5.3.0-3) unstable; urgency=medium

  * Restore the i386 package, depending on sse2-support so that
    installations on platforms without the required SSE2 support will
    fail. Closes: #961710.
  * Add rr-collect-symbols manpage.

 -- Stephen Kitt <skitt@debian.org>  Sat, 30 May 2020 14:49:46 +0200

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,9 @@
 Priority: optional
 Build-Depends: capnproto,
                cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                dh-python,
-               g++-multilib,
+               g++-multilib | g++-i686-linux-gnu,
                gdb,
                libcapnp-dev,
                libdisasm-dev,
@@ -23,10 +23,11 @@
 Rules-Requires-Root: no
 
 Package: rr
-Architecture: amd64
+Architecture: amd64 i386
 Depends: ${misc:Depends},
          ${python3:Depends},
-         ${shlibs:Depends}
+         ${shlibs:Depends},
+         sse2-support [i386]
 Description: application execution recorder, player and debugger
  rr allows application executions to be recorded and then replayed
  with gdb as many times as desired.
@@ -36,5 +37,5 @@
  always identical from one run to another.
  .
  rr is incompatible with ptrace hardening, and currently only supports
- Intel CPUs with Nehalem or later microarchitectures. The amd64
- package supports debugging amd64 and i386 binaries.
+ Intel CPUs with Nehalem or later microarchitectures, and some Zen
+ CPUs. The amd64 package supports debugging amd64 and i386 binaries.

## rr 5.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -34,7 +34,7 @@
 # debian is happy with it.  However, "_" is illegal in debs, while RPM
 # is cool with it.  Sigh.
 set(rr_VERSION_MAJOR 5)
-set(rr_VERSION_MINOR 4)
+set(rr_VERSION_MINOR 5)
 set(rr_VERSION_PATCH 0)
 
 add_definitions(-DRR_VERSION="${rr_VERSION_MAJOR}.${rr_VERSION_MINOR}.${rr_VERSION_PATCH}")
@@ -55,7 +55,7 @@
 set(x86ish false)
 if (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "aarch64")
   set(supports32bit false)
-  set(FLAGS_COMMON "${FLAGS_COMMON} -march=armv8.3-a")
+  set(FLAGS_COMMON "${FLAGS_COMMON} -march=armv8.3-a -Wl,-dynamic-linker=/lib/aarch64-linux-gnu/atomics/ld-linux-aarch64.so.1")
 else()
   set(x86ish true)
   set(FLAGS_COMMON "${FLAGS_COMMON} -msse2 -D__MMX__ -D__SSE__ -D__SSE2__")
@@ -151,7 +151,7 @@
   # try_compile won't accept LINK_FLAGS, so do this manually.
   file(WRITE "${CMAKE_BINARY_DIR}/test32.c" "int main() { return 0; }")
   execute_process(COMMAND ${CMAKE_C_COMPILER} -o ${CMAKE_BINARY_DIR}/test32 ${CMAKE_BINARY_DIR}/test32.c -m32
-			RESULT_VARIABLE COMPILER_32BIT_RESULT)
+                  RESULT_VARIABLE COMPILER_32BIT_RESULT)
   if(NOT (COMPILER_32BIT_RESULT EQUAL 0))
     message(FATAL_ERROR "Your toolchain doesn't support 32-bit cross-compilation. Install the required packages or pass -Ddisable32bit=ON to cmake.")
   endif()
@@ -184,7 +184,7 @@
 
 find_program(CAPNP capnp)
 if(${CAPNP} STREQUAL "CAPNP-NOTFOUND")
-  message(FATAL_ERROR "Can't find 'capnp' command; install Capnproto packages? https://github.com/mozilla/rr/wiki/Building-And-Installing#tldr")
+  message(FATAL_ERROR "Can't find 'capnp' command; install Capnproto packages? https://github.com/rr-debugger/rr/wiki/Building-And-Installing#tldr")
 endif()
 
 set(REQUIRED_LIBS
@@ -306,12 +306,6 @@
 
 foreach(py_module ${REQUIRED_PYTHON_MODULES})
   execute_process(COMMAND "${PYTHON_EXECUTABLE}" "-c"
-			"import ${py_module}"
-			RESULT_VARIABLE module_status)
+                  "import ${py_module}"
+                  RESULT_VARIABLE module_status)
   if(module_status)
-    message(FATAL_ERROR "Couldn't find required Python module ${py_module}.")
-  endif()
-endforeach(py_module)
-
-if(WILL_RUN_TESTS)
-  # Check for gdb

=== debian/changelog ===
rr (5.5.0-1ubuntu0.1) jammy; urgency=medium

  * debian/patches: Add support for AMD Phoenix Zen 4 CPU (LP: #2065141)

 -- Marco Trevisan (Treviño) <marco@ubuntu.com>  Wed, 08 May 2024 09:02:10 +0200

rr (5.5.0-1build1) jammy; urgency=medium

  * No-change rebuild against libcapnp-0.8.0

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 07 Mar 2022 17:01:17 +0000

rr (5.5.0-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version 4.6.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Mon, 04 Oct 2021 08:24:33 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: rr
-Maintainer: Stephen Kitt <skitt@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Stephen Kitt <skitt@debian.org>
 Section: devel
 Priority: optional
 Build-Depends: capnproto,
                cmake,
                debhelper-compat (= 13),
                dh-python,
-               g++-multilib | g++-i686-linux-gnu,
+               g++-multilib,
                gdb,
                libcapnp-dev,
                libdisasm-dev,
@@ -16,7 +17,7 @@
                python3-pexpect
 # The following are required for the test suite
 # realpath
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/debian/rr
 Vcs-Git: https://salsa.debian.org/debian/rr.git
 Homepage: http://rr-project.org

=== debian/rules ===
--- 
+++ 
@@ -23,15 +23,18 @@
 	mv debian/rr/usr/bin/rr-collect-symbols.py debian/rr/usr/bin/rr-collect-symbols
 	mkdir -p debian/rr/usr/lib/rr
 	mv debian/rr/usr/bin/rr_* debian/rr/usr/lib/rr/
-	mv debian/rr/usr/lib/$(DEB_HOST_MULTIARCH)/rr/librrpreload* debian/rr/usr/lib/rr/
+	mv debian/rr/usr/lib/$(DEB_HOST_MULTIARCH)/rr/lib*.so debian/rr/usr/lib/rr/
 	rm -rf debian/rr/usr/lib/$(DEB_HOST_MULTIARCH)
 	chmod 644 debian/rr/usr/share/bash-completion/completions/rr
 
 override_dh_strip:
-	dh_strip -Xlibrrpreload
+	dh_strip -Xlibrr
 
 override_dh_dwz:
 	dh_dwz --no-dwz-multifile
 
 override_dh_python3:
 	dh_python3 --no-ext-rename
+
+override_dh_makeshlibs:
+	dh_makeshlibs -n
